import { Element } from "xml-js";
declare type MapCallbackFunc<T> = (value: T, index: number, array: T[]) => any;
declare type ForeachCallbackFunc<T> = (value: T, index: number, array: T[]) => void;
declare type FilterCallback<T> = (value: T) => boolean;
declare type Predicate = string | number | FilterCallback<XmlQueryNode<any>>;
declare type XmlQueryNode<T> = Element & {
    __xmlQuery: true;
    originalNode: T;
    query: (predicate: Predicate) => XmlQueryNode<T>;
    queryAll: (predicate: Predicate) => XmlQueryNode<T>;
    map: (callbackfn: MapCallbackFunc<XmlQueryNode<T>>, thisArg?: any) => XmlQueryNode<T>;
    forEach: (callbackfn: ForeachCallbackFunc<XmlQueryNode<T>>, thisArg?: any) => void;
    innerText: () => string;
};
declare type AllowedInput = Element | Element[] | XmlQueryNode<any> | string | number | undefined;
export default function xmlQuery(node: AllowedInput): XmlQueryNode<any>;
export {};
